/*This lib is by me (ScouSin), and is free for anyone to distribute
or download.  I would really like it if you gave me credit if you
use it in any way, but knowing some people on BYOND, some people
just won't give me credit.  I mostly made this lib, because I want
to fight cheating on BYOND.

This being my first lib (and doing this off the top of my head),
don't expect a great interpretation of how it works, since this is
at least half explanation of how to do it.  The hacking program
works (as I know/think so far) by taking a var, and changing it to a
different var.  So this lib will take that knowledge, and show you
how to apply a fix to your game.

This lib assumes that you have decent coding knowledge.  But the
comments are there, just in case you get lost in the explanation.

If you have an added method to add to this security system, or find
a problem with it, I encourage you to post it on the forums (or
better yet) E-mail me at Scous_In@Yahoo.com.

Anyway, onto the lib!*/

var/world
	safety = 0 //The thing that you don't want to be changeable.
	securityoffset1 = 152
/*First line of defense against the hacking program.  Uses a
second notation of vars to check with safety.  Do not use 152 as the
offset amount.  Make your own unique one, or the cheaters might be
able to cheat if they saw this lib.*/
	securityoffset2 = 0
/*Second line of defense against the hacking program.  Will be made
a random number later on in the lib.*/
	securityoffset3 = 0
/*Third line of defense against the hacking program.  This var is a
DYNAMCIC var, so later on, I will show it changing constantly to
avoid being matched and changed.*/
	offsetamount1 = 152
/*Memorize the first line of defense's offset amount.  Make sure it
matches securityoffset1!*/
	offsetamount2 = 0
//Memorize the second line of defense's offset amount.
	offsetamount3 = 0
//Memorize the third line of defense's offset amount.
world/New()
	..()
	securityoffset2 = rand(1,100)
/*Set the second line of defense as a random var between 1 and 100.
Will check later with safety.  Set your own range of random vars!*/
	offsetamount2 = securityoffset2
//Memorize the second line of defense's offset amount.
	securityoffset3 = rand(1,100000)
// Set the third line of defense as a random obscene number.
	offsetamount3 = securityoffset3
//Memorize the third line of defense's offset amount.
	changethirdlinevar()
//Run a new dymanic var for the third line of defense.
proc/changethirdlinevar()
	spawn(100) //After 10 seconds, run this.
		if(safety + offsetamount1 == securityoffset1) //Check it.
			if(safety + offsetamount2 == securityoffset2)
				if(safety + offsetamount2 == securityoffset2)
				else
					world << "Someone cheated, and passed the first two lines!"
			else
				world << "Someone cheated, and passed the first line!"
		else
			world << "Someone cheated!"
		securityoffset3 = rand(1,100000) + safety
//Set the third line of defense as a random obscene number.
		offsetamount3 = securityoffset3
//Memorize the third line of defense's offset amount.
		changethirdlinevar() //Do it again.
mob/verb/Something()
/*Substitute this with what would change the var named 'safety',
like a get verb on gold.*/
	safety ++ //Insert how safety changes here.
	securityoffset1 ++
/*Change the first line of defense THE SAMEEXACT WAY as you changed
safety.*/
	securityoffset2 ++ //Same as the first line of defense.
	securityoffset3 ++ //Same as the above two.
/*You change the two security vars the same as safety, so (in this
case), securityoffset1 would now be at 153, when safety is at 1, and
securityoffset2 (if let's say the random number was 52), would end
up being 53.*/
mob/verb/SomethingElse()
/*Substitute this with when/what you want to try and catch the
cheater(s).*/
	if(safety + offsetamount1 == securityoffset1)
//If safety has not been editted, this should return as true.
		if(safety + offsetamount2 == securityoffset2)
/*If the cheater learned the offset value of the first line of
defense, run this unique second line of defense.*/
			if(safety + offsetamount3 == securityoffset3)
/*If the cheater managed to get the range of the second line of
defense, run this dynamic third line of defense.*/
			else
				world << "Someone cheated, and passed the first two lines!"
		else
			world << "Someone cheated, and passed the first line!"
/*If safety was found uneditted for the first line, but was caught
by the second line, the cheater found out the offset you used for
it, and changed it to match safety.  In this case, you might want to
change the first set of offset vars.*/
	else
		world << "Someone cheated!"
//If safety has been editted, run anti-cheat response here.
mob/verb/SimulateChangeSafety()
	safety = input("Change to what?","safety",safety) as num
//Do this to check to see how the cheater would change safety.
mob/verb/SimulateChangeFirstLineOfDefense()
	offsetamount1 = input("Change to what?","offsetamount1",offsetamount1) as num
	securityoffset1 = input("Change to what?","securityoffset1",securityoffset1) as num
/*Do this to check to see how the cheater would change the First
Line of Defense.*/
mob/verb/SimulateChangeSecondLineOfDefense()
	offsetamount2 = input("Change to what?","offsetamount2",offsetamount2) as num
	securityoffset2 = input("Change to what?","securityoffset2",securityoffset2) as num
/*Do this to check to see how the cheater would change the Second
Line of Defense.*/
mob/Stat() //Display all of the vars.
	stat("safety = ",safety)
	stat("First Line of Defense = ",securityoffset1)
	stat("First Line's Offset = ",offsetamount1)
	stat("Second Line of Defense = ",securityoffset2)
	stat("Second Line's Offset = ",offsetamount2)
	stat("Third Line of Defense = ",securityoffset3)
	stat("Third Line's Offset = ",offsetamount3)

/*Mild mistake pointed out by OneFishDown.

That is all to this lib.  I would like to thank Abra and Castle's
commune for being the first place I heard of this program, and I
would also like to thank Zi and The Sky Is Falling's commune for
getting afflicted by cheaters, which inspired me to try to help
protect BYOND from such cheating, with this lib.  Thanks to Airjoe
for getting one of the editors into my hands, so I could be
reassured of the third line's efficiency.*/